#include "ws2812.h"

void put_pixel(UDOUBLE pixel_grb) {
    pio_sm_put_blocking(pio0, 0, pixel_grb << 8u);
}

UDOUBLE urgb_u32(UBYTE r, UBYTE g, UBYTE b) {
    return
            ((UDOUBLE) (r) << 8) |
            ((UDOUBLE) (g) << 16) |
            (UDOUBLE) (b);
}

UDOUBLE Conversion(UWORD Data,UDOUBLE RGBpwm)
{
    UDOUBLE Data1 = 0;
    unsigned char Red = (Data & RGB565_RED) >> 8;
    unsigned char Green = (Data & RGB565_GREEN) >> 3;
    unsigned char Blue = (Data & RGB565_BLUE) <<3;
    Data1 = (Blue << 16) + (Green << 8) + Red;
    return Data1 & RGBpwm ;

}

void RGB_Breathing()
{
    for(int i=0;i<24;i++)
        {   
            for(int o=0;o<N_PIXELS;o++)
            put_pixel(urgb_u32(i,i,i));  
            sleep_ms(20);
        }
        sleep_ms(300);
    for(int i=24;i>-1;i--)
        {   
            for(int o=0;o<N_PIXELS;o++)
            put_pixel(urgb_u32(i,i,i));  
            sleep_ms(20);
        }
        sleep_ms(100);
}
UDOUBLE wheel(UBYTE data)
{
    if(data<0||data>31)
        return(urgb_u32(0,0,0));
    if(data<10)
        return urgb_u32(31 - data, data, 0);
    if(data<15)
    {
        data -=10;
        return urgb_u32( 0, 31 - data, data);
    }
    data -=15;
    return urgb_u32(data, 0,31 - data);

}

void Rainbow()
{
    UDOUBLE Rc_index = 0;
    for (UBYTE j = 0; j < 256; j++)
    {
        for (UBYTE i = 0; i < N_PIXELS; i++)
        {
            Rc_index=(i *256/ N_PIXELS) + j ;
            put_pixel(wheel(Rc_index&0x1f));
        }
        DEV_Delay_ms(45);
    }

}

void show(UWORD * image,UDOUBLE RGBpwm)
{   
    for (UBYTE i = 0; i < N_PIXELS; i++)      
        put_pixel(Conversion(image[i],RGBpwm));

}
